<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Quản trị Order</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="#" class="nav-link text-right active">
                  <p>Quản trị Orders</p>
                </a>
              </li>
            </ul>
          </li>          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->

  <div class="content-wrapper bg-light p-3">
  <!-- Breadcrumb -->
  <div class="container-fluid">
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><a href="#">Trang chủ</a></li>
      <li class="breadcrumb-item active">Quản trị Order</li>
    </ol>
  </div>
  <!-- /.breadcrumb -->

  <!-- Main content -->
  <div class="container">
          <div class="text-center mt-2 mb-2">
            <h2>Quản trị Order</h2>
          </div>
          <div class="jumbotron container bg-light">
            <div class="row ">
                <div class="col-sm-3 form-group">
                    <label>Trạng thái</label>
                    <select id="select-status" class="form-control">
                        <option value="">-any-</option>
                        <option value="open">open</option>
                        <option value="confirmed">confirmed</option>
                        <option value="cancel">cancel</option>
                    </select>
                </div>
                <div class="col-sm-3 form-group">
                    <label >Loại Pizza</label>
                    <select id="select-pizza" class="form-control">
                        <option value="">-any-</option>
                        <option value="hawaii">hawaii</option>
                        <option value="bacon">bacon</option>
                        <option value="seafood">seafood</option>
                        <option value="chicken">chicken</option>
                        <option value="ocean">ocean</option>
                    </select>
                </div>
        
                <div class="col-sm-3 d-flex align-items-end" >
                    <button id="btn-filter-order" class="btn btn-info align-self-center mt-3">Lọc dữ liệu</button>
                </div>
            </div>
        </div>
        
        <!-- Hidden For Cloning -->
        <div id="hidden-for-cloning" hidden>
            <div class="row form-group property-example">
                <div class="col-sm-3">
                    <label>ID</label>
                </div>
                <div class="col">
                    <input type="text"class="form-control">
                </div>
            </div>
        </div>
        <!-- Modal Detail -->
        <div id="detail-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Order Detail</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form id="detail-form">
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-primary" id="btn-confirm">Confirm</button>
                        <button class="btn btn-secondary" id="btn-cancel">Cancel</button>
                    </div>
                </div>
                </div>
        </div>
        <div class="container">
          <table class="table table-bordered table-striped table-hover" id="order-table">
            <thead>
              <tr>
                <th>Order ID</th>
                <th>Kích cỡ</th>
                <th>Loại Pizza</th>
                <th>Nước uống</th>
                <th>Thành tiền</th>
                <th width="20%">Họ và tên</th>
                <th>Số điện thoại</th>
                <th>Trạng thái</th>
                <th width="10%">Chi tiết</th>
              </tr>
            </thead>
          </table>
        </div>
        
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
  </footer>

</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    
    // mảng orders
    var gOrders = [];
    
    const gORDER_COLUMN = ["orderCode","kichCo","loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","action"]
    const gCOL_ORDER_CODE = 0;
    const gCOL_SIZE = 1;
    const gCOL_PIZZA = 2;
    const gCOL_DRINK = 3;
    const gCOL_TOTAL = 4;
    const gCOL_NAME = 5;
    const gCOL_PHONE = 6;
    const gCOL_STATUS = 7;
    const gCOL_DETAIL = 8;
  
    var gOrderTable = $("#order-table").DataTable({
      columns: [
        { data: gORDER_COLUMN[0]},
        { data: gORDER_COLUMN[1]},
        { data: gORDER_COLUMN[2]},
        { data: gORDER_COLUMN[3]},
        { data: gORDER_COLUMN[4]},
        { data: gORDER_COLUMN[5]},
        { data: gORDER_COLUMN[6]},
        { data: gORDER_COLUMN[7]},
        { data: gORDER_COLUMN[8] ,
          defaultContent: `
            <button class="btn btn-info order-detail">Chi tiết</button>
          `}
      ]
    }) 
    
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(function() {
      onPageLoading();
      $("#order-table").on("click", ".order-detail" ,function() {
          onBtnDetailClick($(this));
      });
      $("#btn-filter-order").click(onBtnFilterOrderClick);
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
    // hàm xử lý sự kiện load trang
    function onPageLoading() {
      ajaxGetAllOrders();
      loadAllOrdersToTable();
    }
    // hàm xử lý sự kiện ấn nút chi tiết
    function onBtnDetailClick(paramButton) {
      var vRowData = getRowDataFromButton(paramButton);
      console.log(vRowData.id);
      console.log(vRowData.orderCode);
      $("#detail-modal").modal("show");
  
      $("#detail-form").html("");
  
      for (const [key, value] of Object.entries(vRowData)) {
          var vNewPropertyInput = $("#hidden-for-cloning").find(".property-example").clone()
          vNewPropertyInput.toggleClass("property-example");
          vNewPropertyInput.find("label").eq(0).text(key);
          vNewPropertyInput.find("input").eq(0).prop("id", "detail-" + key).val(value);
          vNewPropertyInput.appendTo($("#detail-form"));
      }
  
      $("#detail-id").prop("readonly",true);
      $("#detail-orderCode").prop("readonly",true);
  
    }
    // hàm xử lý sự kiện filter order
    function onBtnFilterOrderClick() {
      // khai báo đối tượng chứa dữ liệu filter
      var vFilterFormData = {
          trangThai: "",
          loaiPizza: ""
      }; 
      // B1: thu thập dữ liệu để filter
      getFilterFormData(vFilterFormData);
      // B2: validate (ko cần)
      // B3: xử  lý filter
      filterOrders(vFilterFormData);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm get tất cả order lưu vào tham số toàn cục
    function ajaxGetAllOrders() {
      const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
      $.ajax({
          url: vBASE_URL,
          type: "GET",
          dataType: "json",
          async: false,
          success: function(allOrders) {
              gOrders = allOrders;
              console.log(gOrders);
          }
      })
    }
  
    function getRowDataFromButton(paramButton) {
      var vThisRow = paramButton.closest("tr");
      var vRowData = gOrderTable.row(vThisRow).data();
      return vRowData;
  }
    
    // hàm load tất cả order vào table
    function loadAllOrdersToTable() {
      loadOrdersToTable(gOrders);
    }
    // hàm load orders ở tham số vào table
    function loadOrdersToTable(paramOrders) {
      gOrderTable.clear()
      gOrderTable.rows.add(paramOrders);
      gOrderTable.draw();
    }
  
  
    // hàm thu thập dữ liệu để lọc
    function getFilterFormData(paramFilterFormObj) {
      paramFilterFormObj.trangThai = $("#select-status").val();
      paramFilterFormObj.loaiPizza = $("#select-pizza").val();
    }
  
    // hàm thực hiện lọc và hiển thị lên table
    function filterOrders(paramFilterFormObj) {
      // thực hiện việc lọc
      
      var ordersWithMatchingStatus = gOrders.filter(function(order) {
        var thisOrderStatus = order.trangThai;
        if (thisOrderStatus == null ){
            return false
        }
        return (thisOrderStatus.toLowerCase().includes(paramFilterFormObj.trangThai));
      });
  
      var ordersWithMatchingPizza = ordersWithMatchingStatus.filter(function(order) {
        let thisOrderPizza = order.loaiPizza;
        if (thisOrderPizza == null ){
            return false
        }
        return (thisOrderPizza.toLowerCase().includes(paramFilterFormObj.loaiPizza));
      });
  
  
  
      // load dữ liệu trả về lên table
      loadOrdersToTable(ordersWithMatchingPizza);
    }
  </script>
</body>
</html>
